package REST.Lamp.gradle;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class LampManager implements BoundaryInterface {
    private static List<Lamp> Lamps = new ArrayList<Lamp>();

    public List<Lamp> getAllLamps() {
        return(Lamps);
    }

    public Lamp createLamp() {
        Lamp l= new Lamp();
        Lamps.add(l);
        return(l);
    }

    public Lamp getLampDetail(int lid) {
        return(findById(lid));
    }

    public void turnLampOn(int lid) {
        Lamp l = findById(lid);
        l.turnOn();
    }

    public void turnLampOff(int lid) {
        Lamp l = findById(lid);
        l.turnOff();
    }
    
    // Will be used by PUT; keep the ID of the resource, update "ison" from
    // the payload submitted by PUT.
    
    public void replaceLamp(int lid, Lamp il) {
    	Lamp l = findById(lid);
    	l.updateOnOff(il.isOn());
    }

    private Lamp findById(int lid) {
        Iterator<Lamp> li = Lamps.listIterator();
        while(li.hasNext()) {
            Lamp l = li.next();
            if(l.matchesId(lid)) return(l);
        }
        return(new NullLamp());
    }
}


